> For the complete documentation index, see [llms.txt](https://docs.360dialog.com/partner/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.360dialog.com/partner/onboarding/integration-best-practices/sizing-your-environment-based-on-expected-throughput.md).

# Sizing Your Environment Based on Expected Throughput

If your WABA number receives more requests that it can effectively handle, the message queues can become overloaded, which may lead to a disconnection from the WhatsApp servers. As a result, you will no longer be able to send or receive messages using that number.&#x20;

To avoid this, it's important to manage the volume of messages you send and receive, as exceeding the capacity of your WABA number can cause disruption to your messaging service. Two strategies can be adopted to prevent such cases.

**Minimum speed of web-hook receiving endpoint**

To ensure that your setup can handle your desired use cases and avoid any disconnections, it's important to calculate the minimum requests per second that your web-hook receiving endpoint needs to handle. We recommend using the following formula to calculate this value:

`min_webhook_rps = (max_outgoing_messages * 3) + expected_messages_per_second`

*Note:* The factor of three is used because typically, for each sent message, three notifications will be received *(`sent`, `delivered`, `read`).*

As an example, let's imagine your use case needs to send 20 messages per second, and plans to receive no more than 30 messages per second from your users:

`min_webhook_rps = (20 * 3) + 30 = 90`

In the above example, your web-hook receiving endpoint has to be able to receive at least `90 messages per second.` To determine the potential capacity of your endpoint, we recommend using [wrk](https://github.com/wg/wrk), an open-source HTTP benchmarking tool or a similar alternative.

**Rate Limiting outgoing messages**

Under ideal conditions, accounts with CloudAPI can handle up to **80** messages per second. Ideal conditions include your webhook responding in less than 200ms and having sufficient technical resources to ensure optimal performance.&#x20;

For more information on this topic, please visit the following [page](https://docs.360dialog.com/partner/messaging-and-calling/sending-and-receiving-messages#capacity).&#x20;

{% hint style="info" %}
If you anticipate the need for high message volumes, please reach out to your Partner Manager for assistance well in advance of the event for support.
{% endhint %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.360dialog.com/partner/onboarding/integration-best-practices/sizing-your-environment-based-on-expected-throughput.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
